#include "DAGH.h"
#include "Consts.h"
#include "ADMvar.h"
#include "SArray.h"
#include "TArray.h"
#include "BHmask.h"
#include "Variables.h"
#include "initfortran.h"
#include "input_params.h"
#include "tstep.h"

void initialize(int t, int Level, double *params, ADMscalar *an,
      ADMscalar *bn, ADMscalar *cn, ADMscalar *dn, ADMscalar *phi,
      ADMscalar *temp, int init, int idt, double Time, int myrank)

{
int itc;
int cg;
GridFunction(DIM)<DOUBLE> &st = *(*an).spacetime[0];
int *ntmp = (*(*theMask).nl).data();
int *ni   = (*(*shift_p).n).data();
int *nio  = (*(*shift_po).n).data();
int *npi  = (*(*shift_t).n).data();
int nl;
int num_int_points;
int num_int_pointso;
int np;

// subroutine initialize(params, anm_, an_, anp_, bnm_,  
// bn_, bnp_,      cnm_, cn_, cnp_, dnm_, dn_, dnp_,  
// phi, temp)
//   implicit none
//   INTERFACE
//      subroutine initial(params, a0, b0, c0, d0,  
// phi0)
//        implicit none
//      end subroutine initial
//      subroutine initstep(params, anm, an, anp, bnm,  
// bn, bnp, cnm, cn, cnp,           dnm, dn, dnp,  
// temp)
//        implicit none
//      end subroutine initstep
//      subroutine dump_2d(params, name, u)
//        implicit none
//        character*(*) name
//      end subroutine dump_2d
//   END INTERFACE
     forall(st,t,Level,cg){
       f_initial(FBA(st(t,Level,cg,DAGH_Main)),
       params,
       (*(*an).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*bn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*cn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*dn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*phi).spacetime[0])(t,Level,cg,DAGH_Main).data());
     } end_forall;


     forall(st,t,Level,cg){
       f_initstep(FBA(st(t,Level,cg,DAGH_Main)),
       params,
       (*(*an).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*an).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*an).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*bn).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*bn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*bn).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*cn).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*cn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*cn).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*dn).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*dn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*dn).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*temp).spacetime[0])(t,Level,cg,DAGH_Main).data());
     } end_forall;


// end subroutine initialize

}
